#include <pspkernel.h>
#include <pspgu.h>
#include "glib2d.h"

PSP_MODULE_INFO("App",0,1,1);
PSP_MAIN_THREAD_ATTR(THREAD_ATTR_USER | THREAD_ATTR_VFPU);

/* Callbacks */
int exit_callback(int arg1, int arg2, void *common) {
  sceKernelExitGame();
  return 0; }
int CallbackThread(SceSize args, void *argp) {
  int cbid;
  cbid = sceKernelCreateCallback("Exit Callback", exit_callback, NULL);
  sceKernelRegisterExitCallback(cbid);
  sceKernelSleepThreadCB();
  return 0; }
int SetupCallbacks() {
  int thid = 0;
  thid = sceKernelCreateThread("update_thread", CallbackThread, 0x11, 0xFA0, 0, 0);
  if(thid >= 0) sceKernelStartThread(thid, 0, 0);
  return thid; }

// The famous DVD screensaver.

int main()
{
  SetupCallbacks();
  pspDebugScreenInit();
  gImage* tex = gTexLoad("back.png",G_TRUE);
  
  int size = 42, x=0, y=0, dx=2, dy=2;

  while (1)
  {
    x += dx;
    y += dy;
    if (x < 0 || x+size > G_SCR_W) dx = -dx; 
    if (y < 0 || y+size > G_SCR_H) dy = -dy;
     
    gClear(WHITE);
    
    gBegin(NULL); // No texture
    gSetColor(AZURE);
    gSetScaleWH(size,size);
    gSetCoordXY(x,y);
    gSetAlpha(x*255/G_SCR_W); // Useless alpha effect ;)
    gAdd();
    gEnd();
    
    gFlip(G_TRUE); // Vsync enabled
  }
    
  sceKernelExitGame();
  return 0;
}

    // Alpha & zbuffer
    /*gBegin(NULL);
    gSetColor(AZURE);
    gSetAlpha(255);
    gSetScaleWH(50,50);
    gSetCoordXYZ(195,50,0);
    gAdd();

    gSetColor(CHARTREUSE);
    gSetAlpha(200);
    gSetScaleWH(200,100);
    gSetCoordXYZ(20,20,0);
    gAdd();

    gSetColor(0xFFDDEEFF);
    gSetAlpha(127);
    gSetScaleWH(100,67);
    gSetCoordXYZ(170,60,1);
    gAdd();
    gEnd();*/


    // Coord mode    
    /*gBegin(NULL);
    
    gSetCoordMode(G_UP_LEFT);
    gSetCoordXY(0,0); 
    gAdd();

    gSetCoordMode(G_UP_RIGHT);
    gSetCoordXY(G_SCR_W,0); 
    gAdd();

    gSetCoordMode(G_DOWN_RIGHT);
    gSetCoordXY(G_SCR_W,G_SCR_H); 
    gAdd();

    gSetCoordMode(G_DOWN_LEFT);
    gSetCoordXY(0,G_SCR_H); 
    gAdd();

    gSetCoordMode(G_CENTER);
    gSetCoordXY(G_SCR_W/2,G_SCR_H/2);
    gAdd();

    gEnd();*/


    // Rotations
    /*gBegin(NULL);
    
    gSetScaleWH(10,10);
    gSetCoordMode(G_CENTER);
    
    gSetCoordXY(G_SCR_W/2,G_SCR_H/2);
    gAdd();
    gSetRotation(i);
    gSetCoordXYRelative(30,0,G_TRUE);
    gAdd();
    gSetRotationRelative(i);
    gSetCoordXYRelative(30,0,G_TRUE);
    gAdd();
    gSetRotationRelative(i);
    gSetCoordXYRelative(30,0,G_TRUE);
    gAdd();
    gSetRotationRelative(i);
    gSetCoordXYRelative(30,0,G_TRUE);
    gAdd();
    
    gEnd();*/
    
    
    // Pop/Push
    /*gBegin(tex);
    gSetScaleWH(15,15);
    gSetCoordMode(G_CENTER);
    gSetRotation(i);
    gSetCoordXY(G_SCR_W/2,G_SCR_H/2);
    gAdd();
    gResetRotation();
    
    for (j=0; j!=4; j++)
    {
      gPush();
      gSetAlpha(200);
      gSetCoordXYRelative(30,0,G_TRUE);
      gAdd();
      gPush();
      gSetAlpha(127);
      gSetCoordXYRelative(30,-10,G_TRUE);
      gAdd();
      gPop();
      gSetScaleWH(5,5);
      gSetCoordXYRelative(30,10,G_TRUE);
      gAdd();
      gPop();
      gSetRotationRelative(360/4);
    }*/
   
   
    // A tree.
    /*int depth_max=5, branches=6;
    void drawBranches(float size, float angle, int depth)
    {
      if (depth == depth_max) return;
      int i;
      gSetRotationRelative(-(branches-1)*angle/2);
      for (i=0; i!=branches; i++)
      {
        gSetScaleWH(size,1);
        gSetAlpha(255-depth*40);
        gAdd();
        gPush();
        gSetCoordXYRelative(size,0,G_TRUE);
        drawBranches(2.f*size/3.f,angle,depth+1);
        gPop();
        gSetRotationRelative(angle);
      }
    }*/
    /*gSetColor(0xFF113B5B);
    gSetCoordMode(G_DOWN_LEFT);
    gSetRotation(-90);
    gSetScaleWH(i*size/1000,1);
    gSetCoordXY(G_SCR_W/2,G_SCR_H);
    gAdd();    
    gSetColor(0xFF457217);
    gSetCoordXYRelative((i*size/1000),0,G_TRUE);
    drawBranches((i*size/1000)/2,angle,0);*/

    // Simple image rotation    
    /*gBegin(tex);
    gSetCoordMode(G_CENTER);
    gSetCoordXY(G_SCR_W/2,G_SCR_H/2);
    gSetRotation(i);
    gSetScale(2,2);
    gAdd();
    gEnd();*/
